function a=ang(x,y,opt)

% ANG angle between two n-dimensional vectors
% 
% function a=ang(x,y,opt)
% uses subfunction p=cp(x,y)
% Calculates the angle between two vector of any dimension.
% Uses usual cross internal product <x,y>=sum(x.*y) or cp(x,y)
% DEFINITION: cos(theta)=<x,y>/( <x,x>^(1/2) *  <y,y>^(1/2) )
% opt = 0 (default) in radians, otherwise - degrees
%
% Susana Vinga $v0$ 23-Mai-2002
% $v1 25Mai02 - correct cos_t>1

if length(x)~=length(y)
   warning('Choose angles with same dimension!');
   return;
end

xy=cp(x,y);
xx=cp(x,x);
yy=cp(y,y);

cos_t = xy / (xx^0.5*yy^0.5);	%cos(theta)=...see definition

%**Next lines to assure we won't obtain complex arcs
if cos_t>1
   cos_t=1;
end
if cos_t<-1
   cos_t=-1;
end
%**

   
a=acos(cos_t);

if ((nargin<3) | (opt==0))
   return;
end

a=a*180/pi;

%**subfunction cross-product cp to other metric
%**change cross-producto definition here
function p=cp(x,y)
	p=sum(x.*y);



