function cg=cgcgr1(cg)

% function cg=cgcgr1(cg)
% Determination of cgr coordinates for all sequences
% 			{FULL BINARY ID MODE}
%
% Tbox: CG - generalized Chaos Game, Forward and Backward
%
% Initial version: Jonas Almeida, 12 Jan 2001
% Update 1 : Jonas Almeida, 12 Jan 2001
% included in NASC, Susana Vinga 5Abr02


% n = number of necessary bits
nb=length(cg.tp);

% ns = number of sequences
ns=length(cg.seq);

%disp('	')
%disp('----------------------------------------')
%disp('Progress report: sequence being analyzed ')
%disp('----------------------------------------')

for i=1:ns
   %disp(strcat(num2str(i),'/',num2str(ns)));
   seq=char(cg.seq(i));
   nn=length(seq);
   for j=1:nn
      b(j,:)=(cg.tp==seq(j));
   end
   
   % Determination of cgr coordinates:
   % CGR(i) = CGR(i-1) + 0.5*(1-CGR(i-1))*b(i) - 0.5*CGR(i-1)*(1-b(i)) 
   % cgr0=0.5*ones(1,nb);nn=length(b(:,1));
   cgr0=rand(1,nb);nn=length(b(:,1));
   
   % ----> FORWARD <----
   
   cgr(1,:)=cgr0+(0.5*(1-cgr0)).*b(1,:)-(0.5*cgr0).*(1-b(1,:));
      for j=2:nn
         cgr(j,:)=cgr(j-1,:)+(0.5*(1-cgr(j-1,:))).*b(j,:)-(0.5*cgr(j-1,:)).*(1-b(j,:));
      end
   cg.cgrs(i).cgr=cgr;
   
   % ----> BACKWARD <----
   
   cgr(nn,:)=cgr0+(0.5*(1-cgr0)).*b(nn,:)-(0.5*cgr0).*(1-b(nn,:));
      for j=nn-1:-1:1
         cgr(j,:)=cgr(j+1,:)+(0.5*(1-cgr(j+1,:))).*b(j,:)-(0.5*cgr(j+1,:)).*(1-b(j,:));
      end
   cg.cgrs(i).cgr=[cg.cgrs(i).cgr,cgr];

   
   b=[];cgr=[];
end

%disp('----------------------------------------')


