function cg=cgcria(txt,opt)

% function cg=cgcria(txt)
% Main function, sequence of steps:
% 1. CGLE --> reads txt file with sequences
% 2. CGTP --> indentification of unique unit components
% 3. CGCGR --> Chaos Game Representation
%
% opt: optinonal parm for compact (0, default) or full (1) binary ID
%
% Tbox: CG - generalized Chaos Game
%
% Initial version: Jonas Almeida, 12 Jan 2001
% Update 1 : Jonas Almeida, 12 Jan 2001
% included in NASC, Susana Vinga 5Abr02

if nargin<2;opt=0;end

% Resetting log reccord:
% if exist('cglog.txt')==2
%   delete('cglog.txt');
%end
%diary('cglog.txt');

% 1. CGLE --> reads txt file with sequences
%disp('	')
%disp(strcat('File name:	',txt,'	Date:	',datestr(now,'dd-mmm-yyyy HH:MM:SS')));
%disp('++++++++++++++++++++++++++++++++++++++++++++++++++')
%disp('1. CGLE --> reads txt file with sequences')
%disp('++++++++++++++++++++++++++++++++++++++++++++++++++')
cg=cgle(txt);

% 2. CGTP --> indentification of unique unit components
%disp('	')
%disp('++++++++++++++++++++++++++++++++++++++++++++++++++')
%disp('2. CGTP ; CGCODE --> indentification of unique unit components')
%if opt==0;disp('	(compact binary extraction)');else;disp('	(full binary extraction)');end
%disp('++++++++++++++++++++++++++++++++++++++++++++++++++')
cg=cgtp(cg);
if opt==0;cg=cgcode(cg);end	% Compact mode
% 3. CGCGR --> Chaos Game Representation
%disp('	')
%disp('++++++++++++++++++++++++++++++++++++++++++++++++++')
%disp('3. CGCGR --> Chaos Game Representation (forward and backward)')
%disp('++++++++++++++++++++++++++++++++++++++++++++++++++')
if opt==0
   cg=cgcgr0(cg);		% Compact binary ID
else
   cg=cgcgr1(cg);		% Full binary ID
end

%diary off