function cg=cgle(txt)

% function cg=cgle(txt)
% Reads text file with sequences
% with the format:
%
% >> Global title / description (the very first line)
% > reference of 1st sequence (the second line)
% .....
% .....  (1st sequence)
% .....
% > reference of 2nd sequence
% .....
% .....  (2nd sequence)
% .....
%
%  (...)
%
% > reference of nth sequence
% .....
% .....  (nth sequence)
% .....
%
%{the only reserved character in this format is ">"}
%
% cg is a structured variable of the type:
% cg.ref = global description / title
% cg.refs = contains n references
% cg.seqs = contains n sequences
%
% Tbox: CG - generalized Chaos Game
%
% Initial version: Jonas Almeida, 12 Jan 2001
% Update 1 : Jonas Almeida, 12 Jan 2001
% included in NASC, Susana Vinga 5Abr02



fid=fopen(txt,'r');

% READS TITLE cg.ref

cg.ref=fgetl(fid);
if cg.ref(1:2)=='>>'
   cg.ref(1:2)=[];
   %disp('	')
   %disp(strcat('File description:',cg.ref));
else
   error('Format error: first line (title) must start with ">>"')
end

   
% READS INDIVIDUAL SEQUENCES AND THEIR REFERENCES; cg.seqs e cg.refs

i=1;linha=fgetl(fid);seqi=[];
if linha(1)=='>'
   cg.refs{i}=linha(2:end);
else 
   error('Format error: description of first sequence not preceded by ">"')
end
%disp('----------------------------------------')
%disp('Sequences read:')
%disp('description	(# units)')
%disp('----------------------------------------')

while feof(fid)==0
   linha=fgetl(fid);
   if linha(1)=='>'
      cg.seq{i}=seqi;%disp(strcat(cg.refs{i},'	(',num2str(length(seqi)),')'));
      i=i+1;cg.refs{i}=linha(2:end);seqi=[];
   else
      seqi=[seqi,linha];
   end      
end


cg.seq{i}=seqi;% disp(strcat(cg.refs{i},'	(',num2str(length(seqi)),')'));
%disp('----------------------------------------')
%disp(strcat('number of sequences:	',num2str(length(cg.seq))))
%disp('----------------------------------------')



fclose(fid);
