function nas=crossd(nas)

% CROSSD crosstabulation of distances between sequences - NASC
%
% function nas=crossd(nas)
% Adds new field to nas
% nas.crossd{i,j}: cell with total homology (with sobredetermination) btwn seq i and j
% fwd+bck coordinates
% NOTE: USM coordinates already created! funtion cgcria
% Non Aligned Sequence Comparision Toolbox - NASC
% $v0.0, Susana Vinga, 6 Mar 2002
% $v0.1, 7 Mar 2002; v0.2, 12Mar02 more comments; 5Abr02

LIMIT=1e-308;	%if diference is less than limit, then LIMIT is taken to calculate logarithm
q=length(nas.cgrs);	% q - number of sequences
[s,t]=size(nas.cgrs(1).cgr);	% s - number of symbols in the 1st.sequence; t - 2*(number of uu)
t2=t/2;
for i=1:q
   for j=1:q
      if i<j	%distances (i,j)=(j,i)
         %***distance between sequences ith and jth***
         
         % extract USM coordinates of sequences i and j
         seqi_f=nas.cgrs(i).cgr(:,1:t2);	%i.th sequence coordinates: each row, one symbol forward coord.
         seqi_b=nas.cgrs(i).cgr(:,t2+1:end); % " -backward coordinates
         seqj_f=nas.cgrs(j).cgr(:,1:t2);
         seqj_b=nas.cgrs(j).cgr(:,t2+1:end);
         disp(strcat('Comparing sequences ',num2str(i),' with ',num2str(j)));
			         
         % compare all symbols with all symbols
         for k=1:length(seqi_f)
            for l=1:length(seqj_f)
         	     dist_f=-log2(max (LIMIT, max(abs(seqi_f(k,:)-seqj_f(l,:)))) );
                 dist_b=-log2(max (LIMIT, max(abs(seqi_b(k,:)-seqj_b(l,:)))) );
                 dist(k,l)=dist_f+dist_b;	%total homology btwn k.th symbol (ith.seq) and l.th (jth)
            end
         end
         nas.crossd{i,j}=dist;	%cell {i,j} is matrix of all crossed distances
         clear dist;
      end	%...distances between ith and jth (i<j)
   end
end

      
               