function nas=overlap(nas)

% OVERLAP capability of words	- NASC
%
% function nas=overlap(nas)
% Calculates for each word in data base its Overlap Capability Qk
% Qk = 1 if k first characters == last k; 0 otherwise.
% nas.words {1xn cell} of s
% nas.overlap will be of the same size
% Qk is important to calculate variances of frequencies of words for calculation of Mahalanobis distance
% Non-Aligned Sequence Comparison Toolbox
% Susana Vinga, 7Mar02; 12Mar02; 5Abr02


r=length(nas.words);	%number of different resolutions

Q=[];
for i=1:r	%for all resolution i
   w=nas.words{i};
   [s,L]=size(w);	%s: num of words; L:num of characters for ith resolution-word length
   for j=1:s	%for all words present - rows
      for k=1:L-1
         Q(j,k)=strcmp(w(j,1:k),w(j,L-k+1:L));
      end
   end
   nas.overlap{i}=Q;
   clear Q;
end