function nas=word_cov(nas)

% WORD_COV covariances of subsequence counts of words - NASC
%
% function nas=word_cov(nas)
% Adds fiels .cov with covariances of counts for each resolution, sequence and word
% cov{i}{j}(m,t) : covariance for ith resolution of words present in jth sequence - cov between mth and t.th words
% options for virtual pool (not yet implemented:
% 1 -> p=1/a with a number of symbols (only implemented here)
% 2 -> typical of specie considered
% 3 -> sample data
% Reference: Uses same notation as paper "Wu et al. A Measure of DNA Sequence Dissimilariy...Biometrics 53" #48
%
% Susana Vinga, v0.0, 1Abr02; 2Abr; 4Abr; 5Abr02
%
% ALL SEQUENCES are considered to have the same SIGMA-pooled variance used in distance.m

a=length(nas.tp);	%number of symbols in alphabet

for i=1:length(nas.L)	%***for each resolution i (in L)

     L=sum(nas.counts{i});	%line vector with number of counted words for each sequence and resolution -> l do artigo
     n=nas.L(i);	%word length
     disp( strcat('Word length: ',num2str(n)) );
     % L+n-1 -> sequence length - VECTOR!!
     w=nas.words{i};
     ww=length(w);	%number of different words
     
     Pn=(1/a)^n;	%independence and uniform model of base comparision
     Rn=(1/a)^n;
     
     %***compare all words (common to all sequences)
     for m=1:ww
        for t=1:ww
           for cap=1:n-1
              %strcmp( w(m,1:cap) , w(t,n-cap+1:n) )
              C{i}(cap,m,t)=strcmp( w(m,n-cap+1:n) , w(t,1:cap) );	%inverso devido a incompatibilidade *com 3Dmatrix
              
           end
        end
     end
              
     % C{i}(m,t,cap) for resolution i, compare word m and t for cap sovraposition/overlap
		% este erro poderia ser corrigido com a funo RESHAPE or SQUEEZE
  
  	 if n==1	%variance and covariance of a symbol -> multinomial/binomial: valid only for Rn=Pn=1/a
        %cov{i}=kron(ones(length(nas.words{i}),1),varN1);
        %cov{i}=1;
        for j=1:length(nas.seq)	%***for each sequence j (in seq)
           cov{i}{j}=L(j).*( (1/a)*eye(ww)-(1/a)^2*ones(ww) );
        end
        
             
     else	% n>1
        for j=1:length(nas.seq)	%***for each sequence j (in seq)
           	fprintf( ['\tSeq: ',num2str(j),'\n'] )
				%disp( strcat('    Seq: ',num2str(j)) );	%not \t, \n          
            Lk=L(j)-1:-1:L(j)-n+1;	%(l-k) in sum (see paper); **dim=n-1
         	for p=1:n-1
               Pk(p)=(1/a)^p;		%Pk; ***dim=n-1
               Rk(p)=(1/a)^p;		%Rk
            end
            
                                     
            for m=1:ww
               for t=1:ww
                  
            	%compare word j and m - overlap capability
            	c1=C{i}(n-1:-1:1,m,t); %vector to sum mt ***dim=n-1
               c2=C{i}(n-1:-1:1,t,m); %sum tm
               
               %alternativ: reshape(c1,1,?) or squeeze(c1)
                         
          		soma1=sum(Lk.*Pk.*c1');
            	soma2=sum(Lk.*Rk.*c2');
            
               cov{i}{j}(m,t)=(L(j)-n+1)*(L(j)-n)*Pn*Rn+Rn*soma1+Pn*soma2-L(j)^2*Pn*Rn;
      %***ERROR: diag(cov) is different of var!!!  check formulas.***
				%control                  
            %   if (i==4)&(j==1)&(m==34)&(t==40)
            %   	Lk
            %   	Pk
            %   	Rk
            %     c1
            %     c2
        	   %  	C{i}(:,34,40)
            % 	   soma1
            %		soma2
          	%		cov{i}{j}(34,40)
            %		cov{i}{j}(40,34)
            %end
         		end
            end
               
            
        end
      end
      
   end
     
%%%pooled variance implemented in classif.m
     
nas.cov=cov;	%nas.cov{i}{j}(m,t) is covariance between m.th and t.th word (ith resolution) in jth sequence


%clf.counts{i}	%row corresponds to row in clf.words{i}; col to each sequence
%clf.freqs{i} same thing but with relative frequencies (divide by total)