function nas=word_var(nas)

% WORD_VAR variances of subsequence counts of words - NASC
%
% function nas=word_var(nas)
% Adds fiels .var with variances of counts for each resolution, sequence and word
% var(counts)=lPn(1-lPn)+Pn^2(l-n+1)(l-n)+2Pn*sum[(l-k)PkQn-k]_1^n-1
% options for virtual pool (not yet implemented:
% 1 -> p=1/a with a number of symbols
% 2 -> typical of specie considered
% 3 -> sample data
% Reference: Uses same notation as paper "Wu et al. A Measure of DNA Sequence Dissimilariy...Biometrics 53" #48
%
% Susana Vinga, v0.0, 26Mar02; 5Abr02

a=length(nas.tp);	%number of symbols in alphabet

for i=1:length(nas.L)	%for each resolution i (in L)
     L=sum(nas.counts{i});	%vector with number of counted words for each sequence and resolution -> l do artigo
     n=nas.L(i);	%word length
     % L+n-1 -> sequence length
     Pn=(1/a)^n;	%independence and uniform model of base comparision
     varN1=(L*Pn).*(1-L*Pn)+Pn^2*(L-n+1).*(L-n);	%vector length seq: equal part vs. variational part
 
 	  %second part of variance. If n=1 is 0 -> simple binomial variance (confirmed)
     if n==1
        varNtot{i}=kron(ones(length(nas.words{i}),1),varN1);
     else
     		% n>1
     		for j=1:length(nas.seq)	%for each sequence j (in seq)
      	   Lk=L(j)-1:-1:L(j)-n+1;	%in sum (see paper)
         	for p=1:n-1
            	Pk(p)=(1/a)^p;
   	      end
      	   for w=1:length(nas.words{i}) %n-1=length(nas.overlap{i})	for each word!
         	   Qnk=nas.overlap{i}(w,n-1:-1:1);	%already inverted Qn-1 ... Q1 overlaps
               varN2=2*Pn*sum(Lk.*Pk.*Qnk);
              	varNtot{i}(w,j)=varN1(j)+varN2;
        	 	end
          end
       end
end

nas.var=varNtot;


%clf.counts{i}	%row corresponds to row in clf.words{i}; col to each sequence
%clf.freqs{i} same thing but with relative frequencies (divide by total)
%v=